# Inspired by http://sebsauvage.net/python/gui/

#!/usr/bin/python
# -*- coding: iso-8859-1 -*-

# TODO:, string

import Tkinter, serial, sys
from time import sleep

class simpleapp_tk(Tkinter.Tk):
	def __init__(self, parent, ser):
		Tkinter.Tk.__init__(self,parent)
		self.parent = parent
		self.initialize()
		
		# Initialize serial connection
		self.ser = ser
		self.ser.flush()
	
	def initialize(self):
		self.grid()
		
		instructions = Tkinter.Label(self, text=u"Type the text to display:")
		instructions.pack()
		instructions.grid(column=0, row=0)
		
		self.entryVariable = Tkinter.StringVar()
		self.entry = Tkinter.Entry(self,textvariable=self.entryVariable)
		self.entry.grid(column=0,row=1,sticky='EW') # When the cell grows 
													#larger than the widget it 
													#contains, the widget will
													#stick to the East and West
													#(i.e., expand horizontally.)
		self.entry.bind("<Return>", self.OnPressEnter)
		#self.entryVariable.set(u"Enter text here.") # initial value
													
		on_button = Tkinter.Button(self,text=u"Send!",command=self.LedOn)
		on_button.grid(column=1,row=1)
		
		#off_button = Tkinter.Button(self,text=u"OFF",command=self.LedOff)
		#off_button.grid(column=2,row=0)
		
		allon_button = Tkinter.Button(self,text=u"All on!",command=self.LedAllOn)
		allon_button.grid(column=1,row=2)
		
		#alloff_button = Tkinter.Button(self,text=u"ALL OFF",command=self.LedAllOff)
		#alloff_button.grid(column=2,row=1)
		
		quit_button = Tkinter.Button(self,text=u"Quit",command=self.Quit)
		quit_button.grid(column=3, row=1, sticky='EW')
		
		self.labelVariable = Tkinter.StringVar()
		
		label = Tkinter.Label(self, textvariable=self.labelVariable,
			anchor="w",fg="white",bg="blue") # w=left
		label.grid(column=0,row=2,columnspan=1,sticky='EW')
		self.labelVariable.set(u"Hello !") # initial value
			
		self.grid_columnconfigure(0,weight=1) # resize columns and rows with window
		self.resizable(True,False) # resize columns/rows on horizontal resize only
		self.update() # next two lines prevent resize according to length of labl text
		self.geometry(self.geometry())
		self.entry.focus_set() # next two lines: auto-select text-field upon <Enter>
		self.entry.selection_range(0, Tkinter.END)
			
	def OnPressEnter(self,event):
		self.LedOn()
	
	def Quit(self):
		# turn matrix off
		ser.write(')')
		self.destroy()
		
	# TODO: decouple Led Matrix methods from GUI
	
	def LedOn(self):
		#self.labelVariable.set("LED \"" + self.entryVariable.get()+ "\" on!")
		#self.light_led(first_led)
		#self.set_slider.config(state = NORMAL, troughcolor = "#aaa")
		led = self.entryVariable.get().lower() # lowercase
		self.entryVariable.set("")
		#print "ON: " + led
		sent = ser.write(led) 
		print sent
		#self.labelVariable.set("You typed \"" + led + "\";" + sent + " bytes sent.")
		self.labelVariable.set("You typed \"" + led + "\"")
		self.entryVariable.set("")
		self.entry.focus_set()
		
		#matrix_status = ser.read(size=17)
		#print matrix_status + " len: " + len(matrix_status)
		#ser.close()
		
		#matrix_status = ser.read(size=3)
		#self.start_button.config(state = DISABLED)
		#self.stop_button.config(state = NORMAL)
		
	def LedAllOff(self):
		ser.write('#') 
		self.labelVariable.set("You turned all LEDs off!")
		self.entryVariable.set("")
		self.entry.focus_set()

	def LedAllOn(self):
		ser.write('@') 
		self.labelVariable.set("You turned all LEDs on!")
		self.entryVariable.set("")
		self.entry.focus_set()

if __name__ == "__main__":
	'''
	if (len(sys.argv) != 2):
		print "command line: my_gui.py serial_port"
		sys.exit()
	'''
	port = "/dev/tty.usbserial-A6003PX4" # sys.argv[1]
	#
	# open serial port
	#
	ser = serial.Serial(port, 9600)
	ser.setDTR()
	
	app = simpleapp_tk(None, ser)
	app.title('LED matrix')
	app.mainloop()